1. File description

* data：Store raw data and independent test sets


2. Procedure description

* feature-selection.py: Feature selection: obtain 45 'SeqPose Feature' with small correlation with the class label;

* SeqPose-fit.py: Train the model;

* SeqPose-LOO.py: Leave-one-out training and obtain the CSV file storing the prediction results;

* SeqPose-LOO-evaluate.py: Evaluate the leave-one-out method results;

* SeqPose-independent-datasets-test.py: Independent test set verification;


3. Computer environment

* python : Version 3.7.7 

* pandas : Version 1.0.5

* numpy : Version 1.18.5

* keras : Version 2.2.4 

* tensorflow-gpu : Version 1.14.0 
 (We are experimenting on the GPU, so the package installed is the GPU version. It is also recommended that you run on the GPU.)

* theano : Version 1.0.4

* sklearn : Version 0.0

* scikit-learn : Version 0.23.1

* h5py : Version 2.10.0


4. Program execution sequence

a. The 'feature-selection.py' file must be executed first to perform feature selection operations;

b. Secondly, the 'SeqPose-fit.py' file must be executed to obtain SeqPoseDict and train the model;

c. If you want to verify the leave-one method, execute the file seqpose-loo.py, then execute the SeqPose-LOO-evaluate.py program to get the result of the leave-one method; If you want to validate a set of independent tests, execute seqpose-independent-datets-test.py.

