import pandas as pd
from keras.layers import Multiply
from keras.layers import LSTM, Embedding, Bidirectional
from keras.engine import Input, Model
from keras.layers.core import *
from keras.callbacks import ModelCheckpoint
from keras import backend as K
from keras.preprocessing.sequence import pad_sequences
import os
import copy
from keras.layers.normalization import BatchNormalization
import numpy as np
from keras.callbacks import EarlyStopping
import time
import random

k_current = 0  
k = 1

k_merList = [2]
kkk = k_merList[0]
maxlen = 718 
EPCOHS_first = 6 #  an arbitrary cutoff, generally defined as "one pass over the entire dataset", used to separate training into distinct phases, which is useful for logging and periodic evaluation.
EPCOHS_second = 6
BATCH_SIZE = 64 # a set of N samples. The samples in a batch are processed` independently,
                   #in parallel. If training, a batch results in only one update to the model.

RNN_HIDDEN_DIM = 64   
DROPOUT_RATIO_1 = 0.5 # proportion of neurones not used for training    
DROPOUT_RATIO_2 = 0.5 # proportion of neurones not used for training    
xSquare_selection = 45 

checkpoint_dir = './checkpoints'  # Store model files
if not os.path.exists(checkpoint_dir):   # if the path does not exist, generate it
    os.mkdir(checkpoint_dir)

checkpoint_dir = './checkpoints/LOO_model'  # Store model files
if not os.path.exists(checkpoint_dir):   # if the path does not exist, generate it
    os.mkdir(checkpoint_dir)

result_dir = './LOO-result'  # Store model files
if not os.path.exists(result_dir):   # if the path does not exist, generate it
    os.mkdir(result_dir)

output_dir = './output'  # Store model files
if not os.path.exists(output_dir):  # if the path does not exist, generate it
    os.mkdir(output_dir)

useless_filename = './output/Useless_SeqPose_features_'+str(kkk)+'_mer_'+str(xSquare_selection)+'.csv'   # File storing sequence position
filepath = checkpoint_dir + "/model_first-leave-one-method_" + str(k_current+1) +".hdf5"
filepath_second = checkpoint_dir + "/model_second-leave-one-method" + str(k_current+1) +".hdf5"

def readData():
    finalFasta_positive = {}  
    finalFasta_positive_second = {}  
    fileList = ['./data/weak_enhancer.txt', './data/strong_enhancer.txt']  
    for m in fileList:
        fasta = {}  
        second_label = {}  
        if m == './data/strong_enhancer.txt':
            with open(m) as file:
                sequence = ""
                for line in file:
                    if line.startswith(">"):
                        name = line[1:].rstrip()
                        fasta[name] = ''
                        continue
                    fasta[name] += line.rstrip()
                    second_label[name + ' strong'] = 'strong'

                finalFasta_positive = dict(finalFasta_positive, **fasta) 
                finalFasta_positive_second = dict(finalFasta_positive_second, **second_label) 
        else:
            with open(m) as file:  
                sequence = ""
                for line in file:
                    if line.startswith(">"):
                        name = line[1:].rstrip()
                        fasta[name] = ''
                        continue
                    fasta[name] += line.rstrip()  
                    second_label[name + ' weak'] = 'weak'
                finalFasta_positive = dict(finalFasta_positive, **fasta)  
                finalFasta_positive_second = dict(finalFasta_positive_second, **second_label)  

    finalFasta_negative = {}  
    finalFasta_negative_second = {} 
    fasta = {} 
    second_label = {} 
    with open('./data/non-enhancer.txt') as file:
        sequence = ""
        for line in file:
            if line.startswith(">"):
                name = line[1:].rstrip()
                fasta[name] = ''
                continue
            fasta[name] += line.rstrip()  
            second_label[name + ' second label'] = 'non enhancer'
        finalFasta_negative = dict(finalFasta_negative, **fasta) 
        finalFasta_negative_second = dict(finalFasta_negative_second, **second_label)  

    AllPositive_items = list(finalFasta_positive.items())  
    AllNegative_items = list(finalFasta_negative.items()) 

    AllStrength_items = list(finalFasta_positive_second.items()) 

    sequenceList = []  

    for i in range(len(AllPositive_items)):
        tuple_Strength_key = AllStrength_items[i][0]
        tuple_Strength_val = AllStrength_items[i][1]

        tuple_sequence_key = AllPositive_items[i][0]
        tuple_sequence_val = AllPositive_items[i][1]
        if tuple_Strength_key[-2] == 'n':
            tmpDict = {'sequence': tuple_sequence_val, 'target': 1, 'strength': 1}
            sequenceList.append(tmpDict)
        else:
            tmpDict = {'sequence': tuple_sequence_val, 'target': 1, 'strength': 0}
            sequenceList.append(tmpDict)

    for key, value in AllNegative_items:
        if value[-1] != 'r':

            tmpDict = {'sequence': value, 'target': 0,
                       'strength': 333} 
            sequenceList.append(tmpDict)  

    return sequenceList

sequenceList = readData() 

# shuffle
random.seed(75)
random.shuffle(sequenceList)   

# Use kmer to segment raw data
def k_split(sequenceList, k_merList):

    def k_mer(sequence, k):
        
        # kmer algorithm
        splitSequence = []  # Used to store the segmented sequence
        for i in range(len(sequence) - k + 1):
            tmp = ''
            for j in range(i, i + k):
                tmp += sequence[j]

            splitSequence.append(tmp)
        return splitSequence

    finalSequenceList = []
    for k_merNum in k_merList:  
        sequenceTmpList = copy.deepcopy(sequenceList)  
        for i in range(len(sequenceList)):  
            sequenceTmpList[i]['sequence'] = k_mer(sequenceList[i]['sequence'],
                                                   k_merNum)  
            finalSequenceList.append(sequenceTmpList[i])

    # Take each word as a feature,
    avertFinal = finalSequenceList[:len(sequenceList)]
    for i in range(len(k_merList)):
        tmplist = finalSequenceList[len(sequenceList) * i:(i + 1) * len(sequenceList)]
        for dictindex in range(len(tmplist)):
            avertFinal[dictindex]['sequence'] = avertFinal[dictindex]['sequence'] + tmplist[dictindex]['sequence']

    finalSequenceList = avertFinal # finalSequenceList is a list, each element of which is a dictionary, and the sequence in finalSequenceList has been split by k-mer

    wordVectorSeqList = []  
    wordVectorTarList = []  
    wordVectorStrengthList = []  

    for allDictSeq in finalSequenceList:
        wordVectorSeqList.append(allDictSeq['sequence'])  
        wordVectorTarList.append(allDictSeq['target']) 
        wordVectorStrengthList.append(allDictSeq['strength'])

    return wordVectorSeqList, wordVectorTarList, wordVectorStrengthList

wordVectorSeqList, wordVectorTarList, wordVectorStrengthList = k_split(sequenceList, k_merList)

# generate SeqPoseDict
token_dict = {}
token_dict['UNK'] = 0
for pairs in wordVectorSeqList:
    for token in pairs:
        if token not in token_dict:
            token_dict[token] = len(token_dict)    # token_dict 是由词组成的字典，大致如下
# print(token_dict)
SeqPoseDict_length = len(token_dict)

# Serialization
def get_index(sentence):
    global token_dict   
    sequence = []
    for word in sentence:
        try:
            sequence.append(token_dict[word])
        except KeyError:
            sequence.append(0)
    return sequence

def feature_selection(X_data, filename, xSquare_selection):  # Feature selection

    sorted_index_df = pd.read_csv(filename, header=None)
    sorted_index_list = sorted_index_df.iloc[:, 0].tolist()  

    unuseful_column = []
    for i in range(xSquare_selection):
        unuseful_column.append(sorted_index_list[i])
    unuseful_column.sort(reverse=True)  

    for i in range(len(X_data)): 
        for column_ele in unuseful_column:   # column_ele is the position to be deleted
            del X_data[i][column_ele]

    return X_data

X_data = list(map(get_index, wordVectorSeqList))  

print('before:', len(X_data[0]))
# Feature selection
X_data = feature_selection(X_data, useless_filename, xSquare_selection)
print('after:', len(X_data[0]))

# padding
maxlen_tmp = len(X_data[0]) 
if maxlen_tmp < maxlen:
    maxlen = maxlen_tmp  

# Model framework
def Model_TransBERT(input_length, SeqPoseDict_length):
    '''
    Define the classification model
    '''
    INPUT_DIM = SeqPoseDict_length + 1
    OUTPUT_DIM = 768

    def attention_3d_block(inputs, TIME_STEPS):     # attention
        input_dim = int(inputs.shape[2])
        a = Permute((2, 1))(inputs)
        a = Reshape((input_dim, TIME_STEPS))(a) # this line is not useful. It's just to know which dimension is what.
        a = Dense(TIME_STEPS, activation='softmax')(a)
        a_probs = Permute((2, 1), name='attention_vec')(a)
        output_attention_mul = Multiply()([inputs, a_probs])
        return output_attention_mul

    def create_lstm(input_length, rnn_hidden_dim=RNN_HIDDEN_DIM, output_dim=OUTPUT_DIM, input_dim=INPUT_DIM,
                    dropout_1=DROPOUT_RATIO_1, dropout_2=DROPOUT_RATIO_2):

        inputs_1 = Input(shape=(input_length, ))
        inputs_2 = Embedding(input_dim=INPUT_DIM, output_dim=output_dim, name='embedding_layer',
                  trainable=True)(inputs_1)
        bi_lstm_1 = Bidirectional(LSTM(rnn_hidden_dim, return_sequences=True))(inputs_2)
        bn = BatchNormalization()(bi_lstm_1)
        attention_mul_bilstm = attention_3d_block(bn, input_length)
        drop_1 = Dropout(DROPOUT_RATIO_1)(attention_mul_bilstm)
        bi_lstm_1 = Bidirectional(LSTM(rnn_hidden_dim))(drop_1)
        drop_2 = Dropout(DROPOUT_RATIO_2)(bi_lstm_1)
        dense = Dense(1, activation='sigmoid')(drop_2)

        model = Model(inputs_1, dense)

        model.compile('adam', 'binary_crossentropy', metrics=['accuracy'])

        return model

    return create_lstm(input_length)

def format_predict(y_pred_prob):
    y_pre = []
    for prob_ele in y_pred_prob:
        if prob_ele[0] >= 0.5: # class=1
            y_pre.append(1)
        else:
            y_pre.append(0)
    
    return y_pre
    
# Acc
def Model_ACC(model, X_test_first, Y_test_first, BATCH_SIZE):
    
    y_pred = model.predict(X_test_first, batch_size=BATCH_SIZE)
    y_pred = format_predict(y_pred)
    initial_positive = 0
    predict_right = 0  
    predict_wrong = 0  

    initial_negtive = 0 
    predict_negtive = 0  
    predict_right_negtive = 0  

    for i in range(len(y_pred)):
        predict_tmp = y_pred[i]
        initial_tmp = Y_test_first[i]  

        if int(initial_tmp) == 1:
            initial_positive += 1  
        if int(predict_tmp) == 1 and int(initial_tmp) == 1:
            predict_right += 1  
        if int(predict_tmp) == 0 and int(initial_tmp) == 1:
            predict_wrong += 1  

        if int(initial_tmp) == 0:
            initial_negtive += 1 
        if int(predict_tmp) == 1 and int(initial_tmp) == 0:
            predict_negtive += 1 
        if int(predict_tmp) == 0 and int(initial_tmp) == 0:
            predict_right_negtive += 1 

    if (predict_right + predict_negtive + predict_right_negtive + predict_wrong) != 0:
        res = (predict_right + predict_right_negtive) / (
                predict_right + predict_negtive + predict_right_negtive + predict_wrong)
    else:
        res = 0
    return res, y_pred[0][0]  

# Sn
def Model_Sn(model, X_test_first, Y_test_first, BATCH_SIZE):

    y_pred = model.predict(X_test_first, batch_size=BATCH_SIZE)
    y_pred = format_predict(y_pred)
    initial_positive = 0
    predict_right = 0  
    predict_wrong = 0
    for i in range(len(y_pred)):
        predict_tmp = y_pred[i] 
        initial_tmp = Y_test_first[i]  

        if int(initial_tmp) == 1:
            initial_positive += 1 
        if int(predict_tmp) == 1 and int(initial_tmp) == 1:
            predict_right += 1  
        if int(predict_tmp) == 0 and int(initial_tmp) == 1:
            predict_wrong += 1  

    if (predict_right + predict_wrong) != 0:
        res = predict_right / (predict_right + predict_wrong)
    else:
        res = 0

    return res, predict_right 

# Sp
def Model_Sp(model, X_test_first, Y_test_first, BATCH_SIZE):
    
    y_pred = model.predict(X_test_first, batch_size=BATCH_SIZE)
    y_pred = format_predict(y_pred)

    initial_negtive = 0  
    predict_negtive = 0  
    predict_right_negtive = 0  

    for i in range(len(y_pred)):
        predict_tmp = y_pred[i]  
        initial_tmp = Y_test_first[i]  

        if int(initial_tmp) == 0:
            initial_negtive += 1 
        if int(predict_tmp) == 1 and int(initial_tmp) == 0:
            predict_negtive += 1  
        if int(predict_tmp) == 0 and int(initial_tmp) == 0:
            predict_right_negtive += 1 

    if (predict_right_negtive + predict_negtive) != 0:
        res = predict_right_negtive / (predict_right_negtive + predict_negtive)
    else:
        res = 0

    return res

# MCC
def Model_MCC(model, X_test_first, Y_test_first, BATCH_SIZE):
    
    y_pred = model.predict(X_test_first, batch_size=BATCH_SIZE)
    y_pred = format_predict(y_pred)
    initial_positive = 0
    predict_right = 0  
    predict_wrong = 0 

    initial_negtive = 0  
    predict_negtive = 0 
    predict_right_negtive = 0 

    for i in range(len(y_pred)):
        predict_tmp = y_pred[i]  
        initial_tmp = Y_test_first[i]  

        if int(initial_tmp) == 1:
            initial_positive += 1  
        if int(predict_tmp) == 1 and int(initial_tmp) == 1:
            predict_right += 1  
        if int(predict_tmp) == 0 and int(initial_tmp) == 1:
            predict_wrong += 1  

        if int(initial_tmp) == 0:
            initial_negtive += 1 
        if int(predict_tmp) == 1 and int(initial_tmp) == 0:
            predict_negtive += 1  
        if int(predict_tmp) == 0 and int(initial_tmp) == 0:
            predict_right_negtive += 1 

    fenzi = (predict_right * predict_right_negtive) - (predict_negtive * predict_wrong)
    fenmu = ((predict_right + predict_wrong) * (predict_right + predict_wrong) * (
                predict_right_negtive + predict_negtive) * (predict_right_negtive + predict_wrong)) ** 0.5
    if fenmu != 0:
        res = fenzi / fenmu
    else:
        res = 0

    return res

# AUC
def Model_AUC(model, X_test_first, Y_test_first, BATCH_SIZE):

    Test_y_pred_score = model.predict(X_test_first, batch_size=BATCH_SIZE)  
    return Test_y_pred_score


X_pad_first = pad_sequences(X_data, maxlen=maxlen)   
Y_first = wordVectorTarList    

X_pad_second = pad_sequences(X_data, maxlen=maxlen)   
Y_second = wordVectorStrengthList     

ACC_res_first = []  
Sp_res_first = []   
Sn_res_first = []  
Mcc_res_first = []  
AUC_res_first = []  
AUC_true_first = []
AUC_score_first = []

ACC_res_second = [] 
Sp_res_second = []   
Sn_res_second = []   
Mcc_res_second = []  
AUC_res_second = []  
AUC_true_second = []
AUC_score_second = []


predict_label_first = []  
predict_label_second = []  
true_label_first = []   
true_label_second = []   

test_index = int(len(Y_first)-1-(k_current*(len(Y_first)/k)))  

count_iter = 1 # Record the number of cycles

while test_index != int(len(Y_first)-1-((k_current+1)*(len(Y_first)/k))):  
    K.clear_session()   # Release graph
    X_train_first = []   
    X_test_first = []

    Y_train_first = []
    Y_test_first = []

    X_train_second = []   
    X_test_second = []

    Y_train_second = []
    Y_test_second = []  
                            

    X_test_first.append(X_pad_first[test_index]) 
    Y_test_first.append(Y_first[test_index])   

    Y_test_second.append(Y_second[test_index])  

    counterpart_seq_tmp = X_test_first[0]  
    counterpart_label_tmp = Y_test_first[0] 
    true_label_first.append(counterpart_label_tmp)  

    counterpart_label_tmp_second = Y_test_second[0]  

    for i_tmp in range(len(X_pad_first)):  
        seq_tmp = X_pad_first[i_tmp]   
        label_tmp = Y_first[i_tmp]  

        if not (seq_tmp == counterpart_seq_tmp).all():  
            X_train_first.append(seq_tmp)
            Y_train_first.append(label_tmp)

    X_train_first = np.array(X_train_first)
    X_test_first = np.array(X_test_first)

    # first layer
    model = Model_TransBERT(len(X_test_first[0]), SeqPoseDict_length)  
    earlyStopping = EarlyStopping(monitor='val_acc', patience=2, verbose=1, mode='max')
    saveBestModel = ModelCheckpoint(filepath, monitor='val_acc', verbose=1, save_best_only=True, mode='max')
    callbacks_list = [saveBestModel]
    print('Fitting first model...', 'iter number:', count_iter, 'total iter number', int(len(Y_first)/k))
    history = model.fit(X_train_first, Y_train_first, batch_size=BATCH_SIZE, epochs=EPCOHS_first,
                        callbacks=callbacks_list, validation_split=0.1, verbose=1)  

    new_model = Model_TransBERT(len(X_test_first[0]), SeqPoseDict_length)

    delay_time = 6
    print('delay_time', delay_time)
    time.sleep(delay_time)  

    new_model.load_weights(filepath)

    res, predict_res_first = Model_ACC(new_model, X_test_first, Y_test_first, BATCH_SIZE)
    predict_label_first.append(predict_res_first)
    ACC_res_first.append(res)
    print('Test ACC:', res)

    res, predict_right = Model_Sn(new_model, X_test_first, Y_test_first, BATCH_SIZE)  
    Sn_res_first.append(res)
    print('Test Recall:', res)

    res = Model_Sp(new_model, X_test_first, Y_test_first, BATCH_SIZE)
    Sp_res_first.append(res)
    print('Test Sp:', res)

    res = Model_MCC(new_model, X_test_first, Y_test_first, BATCH_SIZE)
    Mcc_res_first.append(res)
    print('Test MCC:', res)

    Test_y_scores = Model_AUC(new_model, X_test_first, Y_test_first, BATCH_SIZE)  # type：[[1/0]]
    AUC_true_first.append(Y_test_first)  # [[[1/0]],[[1/0]], .... ]
    AUC_score_first.append(Test_y_scores) 

    K.clear_session()   
    del X_test_first
    del X_train_first
    del Y_train_first
    del Y_test_first  

    print(counterpart_label_tmp_second)
    if predict_right == 1 and counterpart_label_tmp_second != 333:   
        K.clear_session()  
        
        X_test_second.append(X_pad_second[test_index]) 

        counterpart_seq_tmp_second = X_test_second[0]  
        counterpart_label_tmp_second = Y_test_second[0]  
        
        true_label_second.append(counterpart_label_tmp_second)  

        for i_tmp in range(len(X_pad_second)):  
            seq_tmp = X_pad_second[i_tmp]  
            label_tmp = Y_second[i_tmp] 
            if label_tmp != 333:
                if not (seq_tmp == counterpart_seq_tmp_second).all(): 
                    X_train_second.append(seq_tmp)
                    Y_train_second.append(label_tmp)

        X_train_second = np.array(X_train_second)
        X_test_second = np.array(X_test_second)

        # second layer
        model_second = Model_TransBERT(len(X_train_second[0]), SeqPoseDict_length)  
        earlyStopping = EarlyStopping(monitor='val_acc', patience=2, verbose=1, mode='max')
        saveBestModel = ModelCheckpoint(filepath_second, monitor='val_acc', verbose=1, save_best_only=True, mode='max')
        callbacks_list = [saveBestModel]

        print('Fitting second model...', 'iter number:', count_iter, 'total iter number', int(len(Y_first)/k))
        history = model_second.fit(X_train_second, Y_train_second, batch_size=BATCH_SIZE, epochs=EPCOHS_second,
                                   callbacks=callbacks_list, validation_split=0.1, verbose=1)  

        new_model_second = Model_TransBERT(len(X_test_second[0]), SeqPoseDict_length)

        delay_time = 6
        print('delay_time', delay_time)
        time.sleep(delay_time)  

        new_model_second.load_weights(filepath_second)

        res, predict_res_second = Model_ACC(new_model_second, X_test_second, Y_test_second, BATCH_SIZE)
        predict_label_second.append(predict_res_second)
        ACC_res_second.append(res)
        print('second Test ACC:', res)

        res, predict_right = Model_Sn(new_model_second, X_test_second, Y_test_second, BATCH_SIZE)  
        Sn_res_second.append(res)
        print('second Test Recall:', res)

        res = Model_Sp(new_model_second, X_test_second, Y_test_second, BATCH_SIZE)
        Sp_res_second.append(res)
        print('second Test Sp:', res)

        res = Model_MCC(new_model_second, X_test_second, Y_test_second, BATCH_SIZE)
        Mcc_res_second.append(res)
        print('second Test MCC:', res)

        Test_y_scores_second = Model_AUC(new_model_second, X_test_second, Y_test_second, BATCH_SIZE)  # type：[[1/0]]
        AUC_true_second.append(Y_test_second)  # [[[1/0]],[[1/0]], .... ]
        AUC_score_second.append(Test_y_scores_second)  

        K.clear_session()  # release graph
        del X_test_second
        del X_train_second
        del Y_train_second
        del Y_test_second  

    test_index -= 1 
    count_iter += 1 

AUC_first_score_tmp = []
for i in range(len(AUC_score_first)):
    AUC_first_score_tmp.append(AUC_score_first[i][0])

AUC_second_score_tmp = []
for i in range(len(AUC_score_second)):
    AUC_second_score_tmp.append(AUC_score_second[i][0])


# Write to csv file
my_df_1 = pd.DataFrame(predict_label_first)  # Write the predicted label of the first layer of the model to the csv file
my_df_1.to_csv(result_dir + '/predict_label_first_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_2 = pd.DataFrame(predict_label_second)    # Write the predicted label of the second layer of the model to the csv file
my_df_2.to_csv(result_dir + '/predict_label_second_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_3 = pd.DataFrame(AUC_true_first)    
my_df_3.to_csv(result_dir + '/AUC_first_true_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_4 = pd.DataFrame(AUC_first_score_tmp)    
my_df_4.to_csv(result_dir + '/AUC_first_score_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_5 = pd.DataFrame(AUC_true_second)    
my_df_5.to_csv(result_dir + '/AUC_second_true_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_6 = pd.DataFrame(AUC_second_score_tmp)    
my_df_6.to_csv(result_dir + '/AUC_second_score_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_7 = pd.DataFrame(true_label_first)    # Write the true label of the first layer of the model to the csv file
my_df_7.to_csv(result_dir + '/true_label_first_part'+str(k_current+1)+'.csv', index=False, header=False)

my_df_8 = pd.DataFrame(true_label_second)    # Write the true label of the second layer of the model to the csv file
my_df_8.to_csv(result_dir + '/true_label_second_part'+str(k_current+1)+'.csv', index=False, header=False)